/*
 * PodnikovkaGUI.java
 *
 * Created on 15. jen 2004, 11:27
 */

package cz.vse.xkucf03.pocitani.ekonomie;

import cz.vse.xkucf03.util.*;
import cz.vse.xkucf03.pocitani.matematika.Zaokrouhlovani;

/**
 *
 * @author  x
 */
public class PodnikovkaGUI extends javax.swing.JFrame {
    
    FixniVariabilniNaklady dveObdobi_FNVN;
    int zaokrouhlovatNa = 2;
    //Zvukov efekty
    java.applet.AudioClip zvuk_vypocet = java.applet.Applet.newAudioClip(getClass().getResource("zvuky/vypocet.wav"));
    java.applet.AudioClip zvuk_la = java.applet.Applet.newAudioClip(getClass().getResource("zvuky/la.mid"));
    java.applet.AudioClip zvuk_holkyamasiny = java.applet.Applet.newAudioClip(getClass().getResource("zvuky/holkyamasiny.mid"));
    
    
    /** Creates new form PodnikovkaGUI */
    public PodnikovkaGUI() {
        initComponents();
        
        //Nastaven hlavnho okna
        pozadi.setIcon(new javax.swing.ImageIcon(getClass().getResource("obrazky/blue-bend.jpg")));
        this.setFocusable(true);
        
        //Pidme a nastavme panely
        panel.setFont(new java.awt.Font(null, java.awt.Font.PLAIN, 14));
        
        panel.addTab("FN VN Dv obdob",
        new javax.swing.ImageIcon(getClass().getResource("obrazky/colorscm.png")), 
        dveObdobi, "Pot fixn a variabiln nklady pomoc metody dvou obdob");
        
        panel.addTab("WACC",
        new javax.swing.ImageIcon(getClass().getResource("obrazky/colorscm.png")), 
        wacc, "Pot ven prmrn kapitlov nklady");      
        
        panel.addTab("roky",
        new javax.swing.ImageIcon(getClass().getResource("obrazky/colorscm.png")), 
        uroky, "Potn s roky: stadatel, roitel, fondovatel...");
        
        panel.addTab("O programu",
        new javax.swing.ImageIcon(getClass().getResource("obrazky/info.png")), 
        oProgramu, "Informace o programu");
               
        
        //Inicializace modulu dveObdobi
        dveObdobi_1Q.setDocument(new NumericDocument());
        dveObdobi_1TC.setDocument(new NumericDocument());
        dveObdobi_2Q.setDocument(new NumericDocument());
        dveObdobi_2TC.setDocument(new NumericDocument());
        
        //Inicializace modulu WACC
        wacc_CKnaklady.setDocument(new NumericDocument());
        wacc_VKnaklady.setDocument(new NumericDocument());
        wacc_DanovaSazba.setDocument(new NumericDocument());
        wacc_PomerCKVKStateChanged(null);
        
        //Inicializace rok
            //roitel
            uroky_urocitel_SH.setDocument(new NumericDocument());
            uroky_urocitel_i.setDocument(new NumericDocument());
            uroky_urocitel_n.setDocument(new NumericDocument());
            //roitel
            uroky_odurocitel_BH.setDocument(new NumericDocument());
            uroky_odurocitel_i.setDocument(new NumericDocument());
            uroky_odurocitel_n.setDocument(new NumericDocument());
        
        
        //Progress
        progress_timer.start();
        
        
        
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        dveObdobi = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        dveObdobi_1Q = new javax.swing.JTextField();
        dveObdobi_2Q = new javax.swing.JTextField();
        dveObdobi_1TC = new javax.swing.JTextField();
        dveObdobi_2TC = new javax.swing.JTextField();
        dveObdobi_Pocitej = new javax.swing.JButton();
        dveObdobi_vystup = new javax.swing.JTextArea();
        oProgramu = new javax.swing.JPanel();
        jTextArea1 = new javax.swing.JTextArea();
        progress_timer = new org.netbeans.examples.lib.timerbean.Timer();
        uroky = new javax.swing.JScrollPane();
        uroky2 = new javax.swing.JPanel();
        uroky_urocitel_Pocitej = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        jLabel11 = new javax.swing.JLabel();
        jLabel15 = new javax.swing.JLabel();
        uroky_urocitel_SH = new javax.swing.JTextField();
        uroky_urocitel_i = new javax.swing.JTextField();
        uroky_urocitel_n = new javax.swing.JTextField();
        jLabel19 = new javax.swing.JLabel();
        jLabel20 = new javax.swing.JLabel();
        jLabel21 = new javax.swing.JLabel();
        uroky_urocitel_vystup = new javax.swing.JTextArea();
        jLabel22 = new javax.swing.JLabel();
        jLabel23 = new javax.swing.JLabel();
        jLabel24 = new javax.swing.JLabel();
        jSeparator2 = new javax.swing.JSeparator();
        uroky_odurocitel_Pocitej = new javax.swing.JButton();
        jLabel25 = new javax.swing.JLabel();
        jLabel26 = new javax.swing.JLabel();
        jLabel27 = new javax.swing.JLabel();
        uroky_odurocitel_n = new javax.swing.JTextField();
        uroky_odurocitel_i = new javax.swing.JTextField();
        uroky_odurocitel_BH = new javax.swing.JTextField();
        jLabel28 = new javax.swing.JLabel();
        jLabel29 = new javax.swing.JLabel();
        jLabel30 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        uroky_odurocitel_vystup = new javax.swing.JTextArea();
        wacc = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        wacc_procentVK = new javax.swing.JLabel();
        wacc_procentCK = new javax.swing.JLabel();
        wacc_PomerCKVK = new javax.swing.JSlider();
        wacc_CKnaklady = new javax.swing.JTextField();
        wacc_VKnaklady = new javax.swing.JTextField();
        wacc_DanovaSazba = new javax.swing.JTextField();
        wacc_Pocitej = new javax.swing.JButton();
        wacc_vystup = new javax.swing.JTextArea();
        jLabel9 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        panel = new javax.swing.JTabbedPane();
        progress = new javax.swing.JProgressBar();
        pozadi = new javax.swing.JLabel();

        dveObdobi.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jLabel1.setText("1. obdob\u00ed:");
        jLabel1.setToolTipText("Vyberte obdob\u00ed s nejvy\u0161\u0161\u00edm a nejni\u017e\u0161\u00edm vyroben\u00fdm mno\u017estv\u00edm");
        jLabel1.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        dveObdobi.add(jLabel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 30, -1, 50));

        jLabel2.setText("2. obdob\u00ed:");
        jLabel2.setToolTipText("");
        dveObdobi.add(jLabel2, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 60, -1, -1));

        jLabel3.setText("Mno\u017estv\u00ed:");
        jLabel3.setToolTipText("Vyr\u00e1b\u011bn\u00e9 mno\u017estv\u00ed v natur\u00e1ln\u00edch jednotk\u00e1ch");
        dveObdobi.add(jLabel3, new org.netbeans.lib.awtextra.AbsoluteConstraints(80, 10, -1, -1));

        jLabel4.setText("Celkov\u00e9 n\u00e1klady:");
        dveObdobi.add(jLabel4, new org.netbeans.lib.awtextra.AbsoluteConstraints(170, 10, -1, -1));

        dveObdobi.add(dveObdobi_1Q, new org.netbeans.lib.awtextra.AbsoluteConstraints(80, 30, 80, -1));

        dveObdobi.add(dveObdobi_2Q, new org.netbeans.lib.awtextra.AbsoluteConstraints(80, 60, 80, -1));

        dveObdobi_1TC.setNextFocusableComponent(dveObdobi_2Q);
        dveObdobi.add(dveObdobi_1TC, new org.netbeans.lib.awtextra.AbsoluteConstraints(170, 30, 80, -1));

        dveObdobi_2TC.setNextFocusableComponent(dveObdobi_Pocitej);
        dveObdobi.add(dveObdobi_2TC, new org.netbeans.lib.awtextra.AbsoluteConstraints(170, 60, 80, -1));

        dveObdobi_Pocitej.setText("Po\u010d\u00edtej");
        dveObdobi_Pocitej.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                dveObdobi_PocitejActionPerformed(evt);
            }
        });

        dveObdobi.add(dveObdobi_Pocitej, new org.netbeans.lib.awtextra.AbsoluteConstraints(260, 30, 210, 50));

        dveObdobi_vystup.setEditable(false);
        dveObdobi_vystup.setOpaque(false);
        dveObdobi.add(dveObdobi_vystup, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 90, 450, 90));

        oProgramu.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        oProgramu.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                oProgramuMouseEntered(evt);
            }
        });

        jTextArea1.setEditable(false);
        jTextArea1.setText("Ahoj,\n\ntohle je program Podnikov\u00e1 ekonomika\n");
        jTextArea1.setOpaque(false);
        jTextArea1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTextArea1MouseClicked(evt);
            }
            public void mouseExited(java.awt.event.MouseEvent evt) {
                jTextArea1MouseExited(evt);
            }
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                jTextArea1MouseEntered(evt);
            }
        });

        oProgramu.add(jTextArea1, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, 510, 310));

        progress_timer.setDelay(10L);
        progress_timer.addTimerListener(new org.netbeans.examples.lib.timerbean.TimerListener() {
            public void onTime(java.awt.event.ActionEvent evt) {
                progress_timerOnTime(evt);
            }
        });

        uroky2.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        uroky_urocitel_Pocitej.setText("Po\u010d\u00edtej");
        uroky_urocitel_Pocitej.setNextFocusableComponent(uroky_urocitel_SH);
        uroky_urocitel_Pocitej.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                uroky_urocitel_PocitejActionPerformed(evt);
            }
        });

        uroky2.add(uroky_urocitel_Pocitej, new org.netbeans.lib.awtextra.AbsoluteConstraints(263, 40, 180, -1));

        uroky2.add(jSeparator1, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 130, 430, 10));

        jLabel11.setFont(new java.awt.Font("MS Sans Serif", 0, 16));
        jLabel11.setText("\u00daro\u010ditel");
        uroky2.add(jLabel11, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, -1, 20));

        jLabel15.setFont(new java.awt.Font("MS Sans Serif", 0, 16));
        jLabel15.setText("Zbytek - ve v\u00fdstavb\u011b");
        uroky2.add(jLabel15, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 390, -1, 20));

        uroky_urocitel_SH.setNextFocusableComponent(uroky_urocitel_i);
        uroky2.add(uroky_urocitel_SH, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 40, 80, -1));

        uroky_urocitel_i.setNextFocusableComponent(uroky_urocitel_n);
        uroky2.add(uroky_urocitel_i, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 70, 80, -1));

        uroky_urocitel_n.setNextFocusableComponent(uroky_urocitel_Pocitej);
        uroky2.add(uroky_urocitel_n, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 100, 80, -1));

        jLabel19.setText("Sou\u010dasn\u00e1 hodnota:");
        uroky2.add(jLabel19, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 40, -1, -1));

        jLabel20.setText("\u00darokov\u00e1 sazba:");
        uroky2.add(jLabel20, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 70, -1, 20));

        jLabel21.setText("Po\u010det obdob\u00ed:");
        uroky2.add(jLabel21, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 100, -1, 20));

        uroky_urocitel_vystup.setEditable(false);
        uroky_urocitel_vystup.setLineWrap(true);
        uroky_urocitel_vystup.setOpaque(false);
        uroky2.add(uroky_urocitel_vystup, new org.netbeans.lib.awtextra.AbsoluteConstraints(260, 70, 180, 50));

        jLabel22.setText("K\u010d");
        uroky2.add(jLabel22, new org.netbeans.lib.awtextra.AbsoluteConstraints(230, 40, -1, 20));

        jLabel23.setText("%");
        uroky2.add(jLabel23, new org.netbeans.lib.awtextra.AbsoluteConstraints(230, 70, -1, 20));

        jLabel24.setText("let");
        jLabel24.setToolTipText("V p\u0159\u00edpad\u011b ro\u010dn\u00ed \u00farokov\u00e9 m\u00edry. Nebo jin\u00e9 obdob\u00ed, ale mus\u00ed odpov\u00eddat \u00farokov\u00e9 m\u00ed\u0159e");
        uroky2.add(jLabel24, new org.netbeans.lib.awtextra.AbsoluteConstraints(230, 100, -1, 20));

        uroky2.add(jSeparator2, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 260, 430, 10));

        uroky_odurocitel_Pocitej.setText("Po\u010d\u00edtej");
        uroky_odurocitel_Pocitej.setNextFocusableComponent(uroky_odurocitel_BH);
        uroky_odurocitel_Pocitej.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                uroky_odurocitel_PocitejActionPerformed(evt);
            }
        });

        uroky2.add(uroky_odurocitel_Pocitej, new org.netbeans.lib.awtextra.AbsoluteConstraints(270, 170, 180, -1));

        jLabel25.setText("K\u010d");
        uroky2.add(jLabel25, new org.netbeans.lib.awtextra.AbsoluteConstraints(230, 170, -1, 20));

        jLabel26.setText("%");
        uroky2.add(jLabel26, new org.netbeans.lib.awtextra.AbsoluteConstraints(230, 200, -1, 20));

        jLabel27.setText("let");
        jLabel27.setToolTipText("V p\u0159\u00edpad\u011b ro\u010dn\u00ed \u00farokov\u00e9 m\u00edry. Nebo jin\u00e9 obdob\u00ed, ale mus\u00ed odpov\u00eddat \u00farokov\u00e9 m\u00ed\u0159e");
        uroky2.add(jLabel27, new org.netbeans.lib.awtextra.AbsoluteConstraints(230, 230, -1, 20));

        uroky_odurocitel_n.setNextFocusableComponent(uroky_odurocitel_Pocitej);
        uroky2.add(uroky_odurocitel_n, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 230, 80, -1));

        uroky_odurocitel_i.setNextFocusableComponent(uroky_odurocitel_n);
        uroky_odurocitel_i.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                uroky_odurocitel_iActionPerformed(evt);
            }
        });

        uroky2.add(uroky_odurocitel_i, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 200, 80, -1));

        uroky_odurocitel_BH.setNextFocusableComponent(uroky_odurocitel_i);
        uroky2.add(uroky_odurocitel_BH, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 170, 80, -1));

        jLabel28.setText("Budouc\u00ed hodnota:");
        uroky2.add(jLabel28, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 170, -1, -1));

        jLabel29.setText("\u00darokov\u00e1 sazba:");
        uroky2.add(jLabel29, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 200, -1, 20));

        jLabel30.setText("Po\u010det obdob\u00ed:");
        uroky2.add(jLabel30, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 230, -1, 20));

        jLabel12.setFont(new java.awt.Font("MS Sans Serif", 0, 16));
        jLabel12.setText("Od\u00faro\u010ditel");
        uroky2.add(jLabel12, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 140, -1, 20));

        uroky_odurocitel_vystup.setEditable(false);
        uroky_odurocitel_vystup.setLineWrap(true);
        uroky_odurocitel_vystup.setOpaque(false);
        uroky2.add(uroky_odurocitel_vystup, new org.netbeans.lib.awtextra.AbsoluteConstraints(260, 200, 180, 50));

        uroky.setViewportView(uroky2);

        wacc.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jLabel5.setText("N\u00e1klady na CK:");
        wacc.add(jLabel5, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 40, -1, 20));

        jLabel6.setText("N\u00e1klady na VK:");
        wacc.add(jLabel6, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, -1, 20));

        jLabel7.setText("Danov\u00e1 sazba:");
        wacc.add(jLabel7, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 70, -1, 20));

        wacc_procentVK.setText("VK");
        wacc.add(wacc_procentVK, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 120, 70, -1));

        wacc_procentCK.setText("CK");
        wacc_procentCK.setMaximumSize(null);
        wacc_procentCK.setMinimumSize(null);
        wacc_procentCK.setPreferredSize(null);
        wacc.add(wacc_procentCK, new org.netbeans.lib.awtextra.AbsoluteConstraints(390, 120, 70, -1));

        wacc_PomerCKVK.setToolTipText("Pom\u011br mezi ciz\u00edm a vlastn\u00edm kapit\u00e1lem");
        wacc_PomerCKVK.setNextFocusableComponent(wacc_Pocitej);
        wacc_PomerCKVK.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                wacc_PomerCKVKStateChanged(evt);
            }
        });

        wacc.add(wacc_PomerCKVK, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 100, 460, -1));

        wacc_CKnaklady.setNextFocusableComponent(wacc_DanovaSazba);
        wacc.add(wacc_CKnaklady, new org.netbeans.lib.awtextra.AbsoluteConstraints(100, 40, 150, -1));

        wacc_VKnaklady.setNextFocusableComponent(wacc_CKnaklady);
        wacc.add(wacc_VKnaklady, new org.netbeans.lib.awtextra.AbsoluteConstraints(100, 10, 150, -1));

        wacc_DanovaSazba.setNextFocusableComponent(wacc_PomerCKVK);
        wacc.add(wacc_DanovaSazba, new org.netbeans.lib.awtextra.AbsoluteConstraints(100, 70, 150, -1));

        wacc_Pocitej.setText("Po\u010d\u00edtej");
        wacc_Pocitej.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                wacc_PocitejActionPerformed(evt);
            }
        });

        wacc.add(wacc_Pocitej, new org.netbeans.lib.awtextra.AbsoluteConstraints(280, 10, 190, 80));

        wacc_vystup.setEditable(false);
        wacc_vystup.setOpaque(false);
        wacc.add(wacc_vystup, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 150, 460, 80));

        jLabel9.setText("%");
        wacc.add(jLabel9, new org.netbeans.lib.awtextra.AbsoluteConstraints(260, 70, 10, 20));

        jLabel8.setText("%");
        wacc.add(jLabel8, new org.netbeans.lib.awtextra.AbsoluteConstraints(260, 10, -1, 20));

        jLabel10.setText("%");
        wacc.add(jLabel10, new org.netbeans.lib.awtextra.AbsoluteConstraints(260, 40, -1, 20));

        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        setTitle("Podnikov\u00e1 ekonomika");
        setName("PodnikovkaGUI_okno");
        setResizable(false);
        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                formComponentResized(evt);
            }
        });
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        panel.setAutoscrolls(true);
        getContentPane().add(panel, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 0, 490, 360));

        progress.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                progressMouseClicked(evt);
            }
        });

        getContentPane().add(progress, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 370, 490, -1));

        getContentPane().add(pozadi, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 510, 390));

        pack();
    }//GEN-END:initComponents

    private void uroky_odurocitel_iActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_uroky_odurocitel_iActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_uroky_odurocitel_iActionPerformed

    private void uroky_odurocitel_PocitejActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_uroky_odurocitel_PocitejActionPerformed
        if (!uroky_odurocitel_overVstupy()){
            uroky_odurocitel_vystup.setText("Zadejte vechny hodnoty.");
            return;
        }
        efektPocitani();
        uroky_odurocitel_vystup.setText("Souasn hodnota:\n");
        uroky_odurocitel_vystup.append(Double.toString(Zaokrouhlovani.Zaokrouhli(Podnikovka.odurocitelSH(
        Double.parseDouble(uroky_odurocitel_BH.getText()),
        Double.parseDouble(uroky_odurocitel_i.getText()) / 100,
        Integer.parseInt(uroky_odurocitel_n.getText())
        ), zaokrouhlovatNa)) + " K");
    }//GEN-LAST:event_uroky_odurocitel_PocitejActionPerformed

    private void uroky_urocitel_PocitejActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_uroky_urocitel_PocitejActionPerformed
        if (!uroky_urocitel_overVstupy()){
            uroky_urocitel_vystup.setText("Zadejte vechny hodnoty.");
            return;
        }
        efektPocitani();
        uroky_urocitel_vystup.setText("Budouc hodnota:\n");
        uroky_urocitel_vystup.append(Double.toString(Zaokrouhlovani.Zaokrouhli(Podnikovka.urocitelBH(
        Double.parseDouble(uroky_urocitel_SH.getText()),
        Double.parseDouble(uroky_urocitel_i.getText()) / 100,
        Integer.parseInt(uroky_urocitel_n.getText())
        ), zaokrouhlovatNa)) + " K");
        
    }//GEN-LAST:event_uroky_urocitel_PocitejActionPerformed

    private void jTextArea1MouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTextArea1MouseEntered
        zvuk_holkyamasiny.stop();
        zvuk_la.play();
    }//GEN-LAST:event_jTextArea1MouseEntered

    private void oProgramuMouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_oProgramuMouseEntered
        
    }//GEN-LAST:event_oProgramuMouseEntered

    private void jTextArea1MouseExited(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTextArea1MouseExited
       zvuk_la.stop();
    }//GEN-LAST:event_jTextArea1MouseExited

    private void jTextArea1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTextArea1MouseClicked
        
    }//GEN-LAST:event_jTextArea1MouseClicked
    
    private void progressMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_progressMouseClicked
        zvuk_la.stop();
        zvuk_holkyamasiny.play();
        progress.setValue(0);
        progress_timer.start();
    }//GEN-LAST:event_progressMouseClicked
    
    private void wacc_PocitejActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_wacc_PocitejActionPerformed
        if (!wacc_overVstupy()){
            wacc_vystup.setText("Muste zadat vechny hodnoty\na daov sazba mus bt v rozsahu mezi 0 - 100");
            return;
        }
        
        efektPocitani();
        wacc_vystup.setText("Ven prmrn kapitlov nklady jsou: ");
        wacc_vystup.append(String.valueOf(Zaokrouhlovani.Zaokrouhli(Podnikovka.WACC(
        (Double.parseDouble(wacc_CKnaklady.getText()) / 100),
        (Double.parseDouble(wacc_VKnaklady.getText()) / 100),
        (Double.parseDouble(wacc_DanovaSazba.getText()) / 100),
        (1 - ((double)wacc_PomerCKVK.getValue() / 100))
        ) * 100, zaokrouhlovatNa)) + "%");
        
        
    }//GEN-LAST:event_wacc_PocitejActionPerformed
    
    private void wacc_PomerCKVKStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_wacc_PomerCKVKStateChanged
        wacc_procentVK.setText("VK: " + String.valueOf(100 - wacc_PomerCKVK.getValue()) + "%");
        wacc_procentCK.setText("CK: " + String.valueOf(wacc_PomerCKVK.getValue()) + "%");
        
    }//GEN-LAST:event_wacc_PomerCKVKStateChanged
    
    private void formComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentResized
        
        
    }//GEN-LAST:event_formComponentResized
    
    private void progress_timerOnTime(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_progress_timerOnTime
        if (progress.getValue() != 100) {
            progress.setValue(progress.getValue() + 1);
        }
        else {
            
            //progress_timer.stop();
            //progress.setValue(0);
        }
    }//GEN-LAST:event_progress_timerOnTime
    
    private void dveObdobi_PocitejActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_dveObdobi_PocitejActionPerformed
        if (!dveObdobi_overVstupy()){
            dveObdobi_vystup.setText("Zadejte vechny tyi hodnoty");
            return;
        }
        
        efektPocitani();
        dveObdobi_FNVN = Podnikovka.FnVnDveObdobi(new MnozstviCelkoveNaklady[] {
            new MnozstviCelkoveNaklady(Double.parseDouble(dveObdobi_1Q.getText()), Double.parseDouble(dveObdobi_1TC.getText())),
            new MnozstviCelkoveNaklady(Double.parseDouble(dveObdobi_2Q.getText()), Double.parseDouble(dveObdobi_2TC.getText()))
        });
        
        dveObdobi_vystup.setText("Fixn nklady: " + String.valueOf(Zaokrouhlovani.Zaokrouhli(dveObdobi_FNVN.getFixni(), zaokrouhlovatNa)) + "\n" +
        "Variabiln nklady: " + String.valueOf(Zaokrouhlovani.Zaokrouhli(dveObdobi_FNVN.getVariabilni(), zaokrouhlovatNa)) + "\n" +
        "TC = " + String.valueOf(Zaokrouhlovani.Zaokrouhli(dveObdobi_FNVN.getFixni(), zaokrouhlovatNa) + " + " + String.valueOf(Zaokrouhlovani.Zaokrouhli(dveObdobi_FNVN.getVariabilni(), zaokrouhlovatNa))) + "*Q"
        );
        
        if (dveObdobi_FNVN.getVariabilni() < 0 || dveObdobi_FNVN.getFixni() < 0){
            dveObdobi_vystup.append("\n\nNco je patn: vyla zporn hodnota");
        }
        
    }//GEN-LAST:event_dveObdobi_PocitejActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new PodnikovkaGUI().show();
    }
    
    private boolean dveObdobi_overVstupy() {
        if (dveObdobi_1Q.getText().equalsIgnoreCase("")){
            return false;
        }
        
        if (dveObdobi_1TC.getText().equalsIgnoreCase("")){
            return false;
        }
        
        if (dveObdobi_2Q.getText().equalsIgnoreCase("")){
            return false;
        }
        
        if (dveObdobi_2TC.getText().equalsIgnoreCase("")){
            return false;
        }
        return true;
        
    }
    
    private boolean wacc_overVstupy() {
        if (wacc_VKnaklady.getText().equalsIgnoreCase("")){
            return false;
        }
        
        if (wacc_CKnaklady.getText().equalsIgnoreCase("")){
            return false;
        }
        
        if (wacc_DanovaSazba.getText().equalsIgnoreCase("")){
            return false;
        }
        
        if (Double.parseDouble(wacc_DanovaSazba.getText()) > 100 ||
        Double.parseDouble(wacc_DanovaSazba.getText()) < 0){
            return false;
        }
        return true;
        
    }

    private boolean uroky_urocitel_overVstupy() {
        if (uroky_urocitel_SH.getText().equalsIgnoreCase("")){
            return false;
        }
        
        if (uroky_urocitel_i.getText().equalsIgnoreCase("")){
            return false;
        }
        
        if (uroky_urocitel_n.getText().equalsIgnoreCase("")){
            return false;
        }
        
        if (Double.parseDouble(uroky_urocitel_n.getText()) < 0 ){
            return false;
        }
        return true;
        
    }
    
    private boolean uroky_odurocitel_overVstupy() {
        if (uroky_odurocitel_BH.getText().equalsIgnoreCase("")){
            return false;
        }
        
        if (uroky_odurocitel_i.getText().equalsIgnoreCase("")){
            return false;
        }
        
        if (uroky_odurocitel_n.getText().equalsIgnoreCase("")){
            return false;
        }
        
        if (Double.parseDouble(uroky_odurocitel_n.getText()) < 0 ){
            return false;
        }
        return true;
        
    }
    
    private void efektPocitani() {
        progress.setValue(0);
        progress_timer.start();
        zvuk_vypocet.play();
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel dveObdobi;
    private javax.swing.JTextField dveObdobi_1Q;
    private javax.swing.JTextField dveObdobi_1TC;
    private javax.swing.JTextField dveObdobi_2Q;
    private javax.swing.JTextField dveObdobi_2TC;
    private javax.swing.JButton dveObdobi_Pocitej;
    private javax.swing.JTextArea dveObdobi_vystup;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel23;
    private javax.swing.JLabel jLabel24;
    private javax.swing.JLabel jLabel25;
    private javax.swing.JLabel jLabel26;
    private javax.swing.JLabel jLabel27;
    private javax.swing.JLabel jLabel28;
    private javax.swing.JLabel jLabel29;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel30;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JPanel oProgramu;
    private javax.swing.JTabbedPane panel;
    private javax.swing.JLabel pozadi;
    private javax.swing.JProgressBar progress;
    private org.netbeans.examples.lib.timerbean.Timer progress_timer;
    private javax.swing.JScrollPane uroky;
    private javax.swing.JPanel uroky2;
    private javax.swing.JTextField uroky_odurocitel_BH;
    private javax.swing.JButton uroky_odurocitel_Pocitej;
    private javax.swing.JTextField uroky_odurocitel_i;
    private javax.swing.JTextField uroky_odurocitel_n;
    private javax.swing.JTextArea uroky_odurocitel_vystup;
    private javax.swing.JButton uroky_urocitel_Pocitej;
    private javax.swing.JTextField uroky_urocitel_SH;
    private javax.swing.JTextField uroky_urocitel_i;
    private javax.swing.JTextField uroky_urocitel_n;
    private javax.swing.JTextArea uroky_urocitel_vystup;
    private javax.swing.JPanel wacc;
    private javax.swing.JTextField wacc_CKnaklady;
    private javax.swing.JTextField wacc_DanovaSazba;
    private javax.swing.JButton wacc_Pocitej;
    private javax.swing.JSlider wacc_PomerCKVK;
    private javax.swing.JTextField wacc_VKnaklady;
    private javax.swing.JLabel wacc_procentCK;
    private javax.swing.JLabel wacc_procentVK;
    private javax.swing.JTextArea wacc_vystup;
    // End of variables declaration//GEN-END:variables
    
}
